package com.example.haiwei_mom.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.recyclerview.widget.RecyclerView;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.databinding.ItemBindVehicleBinding;

import java.util.List;

public class BindVehicleAdapter extends RecyclerView.Adapter<BindVehicleAdapter.MyViewHolder> {
    private Context context;
    private LayoutInflater inflater;
    private ItemClickCall itemClickCall;

    public BindVehicleAdapter(Context context, ItemClickCall itemClickCall) {
        this.context = context;
        this.itemClickCall = itemClickCall;
        inflater=LayoutInflater.from(context);
    }

    private List<String> list;

    public void setList(List<String> list) {
        this.list = list;
    }

    @NonNull
    @Override
    public MyViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        ItemBindVehicleBinding binding=DataBindingUtil.inflate(inflater, R.layout.item_bind_vehicle,parent,false);
        return new MyViewHolder(binding);
    }

    @Override
    public void onBindViewHolder(@NonNull MyViewHolder holder, int position) {
        var binding = holder.binding;
        binding.setIndex(String.valueOf(position+1));
        binding.setItem(list.get(position));

    }

    @Override
    public int getItemCount() {
        return list==null?0:list.size();
    }

    public class MyViewHolder extends RecyclerView.ViewHolder{
       private ItemBindVehicleBinding binding;

        public MyViewHolder(ItemBindVehicleBinding binding) {
            super(binding.getRoot());
            this.binding = binding;
        }

        public MyViewHolder(@NonNull View itemView) {
            super(itemView);
        }
    }
}
