package com.example.haiwei_mom.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.recyclerview.widget.RecyclerView;

import com.example.haiwei_mom.BR;
import com.example.haiwei_mom.R;
import com.example.haiwei_mom.databinding.ItemLayoutBinding;
import com.example.haiwei_mom.qm.data.DefectBeen;

import java.util.List;

/**
 * @author wanghao
 * @date 2023/11/17  17:15
 */
public class CheckAdapter extends RecyclerView.Adapter<CheckAdapter.CheckAdapterVH> {
    private Context context;
    private List<DefectBeen> list;
    private LayoutInflater from;
    private CheckItemClickCall checkItemClickCall;

    public CheckAdapter(Context context, CheckItemClickCall checkItemClickCall) {
        this.context = context;
        this.checkItemClickCall = checkItemClickCall;
        from = LayoutInflater.from(context);
    }

    public void setList(List<DefectBeen> list) {
        this.list = list;
    }

    @NonNull
    @Override
    public CheckAdapterVH onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        ItemLayoutBinding inflate1 = DataBindingUtil.inflate(from, R.layout.item_layout, parent, false);
        return new CheckAdapterVH(inflate1);
    }

    @Override
    public void onBindViewHolder(@NonNull CheckAdapterVH holder, int position) {
        DefectBeen defectBeen = list.get(position);
        defectBeen.setIndex(position + 1);
        ItemLayoutBinding databing = holder.getInflate1();
        databing.setVariable(BR.item, defectBeen);
        databing.itemButtom.setOnClickListener(t -> {
            checkItemClickCall.onClick(position);
        });

        databing.executePendingBindings();
    }

    @Override
    public int getItemCount() {
        return list == null ? 0 : list.size();
    }

    class CheckAdapterVH extends RecyclerView.ViewHolder {
        private ItemLayoutBinding inflate1;

        public ItemLayoutBinding getInflate1() {
            return inflate1;
        }

        public CheckAdapterVH(ItemLayoutBinding inflate1) {
            super(inflate1.getRoot());
            this.inflate1 = inflate1;
        }


    }

    public interface CheckItemClickCall {
        void onClick(int positon);
    }

}
