package com.example.haiwei_mom.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.recyclerview.widget.RecyclerView;

import com.example.haiwei_mom.BR;
import com.example.haiwei_mom.R;
import com.example.haiwei_mom.data.WmsBaseLocationVo;
import com.example.haiwei_mom.databinding.ItemLayoutBinding;
import com.example.haiwei_mom.databinding.ItemStoreCheckLocationBinding;
import com.example.haiwei_mom.qm.data.DefectBeen;

import java.util.List;

/**
 * @author wanghao
 * @date 2023/11/17  17:15
 */
public class CheckStoreSelectLocationAdapter extends RecyclerView.Adapter<CheckStoreSelectLocationAdapter.CheckAdapterVH> {
    private Context context;
    private List<WmsBaseLocationVo> list;
    private LayoutInflater from;


    public CheckStoreSelectLocationAdapter(Context context) {
        this.context = context;
        from = LayoutInflater.from(context);
    }

    public void setList(List<WmsBaseLocationVo> list) {
        this.list = list;
    }

    @NonNull
    @Override
    public CheckAdapterVH onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        ItemStoreCheckLocationBinding inflate1 = DataBindingUtil.inflate(from, R.layout.item_store_check_location, parent, false);
        return new CheckAdapterVH(inflate1);
    }

    @Override
    public void onBindViewHolder(@NonNull CheckAdapterVH holder, int position) {
        var item = list.get(position);
        item.setIndex(position + 1);
        var databing = CheckAdapterVH.binding;
        databing.setItem(item);
        // databing.setVariable(BR.item, item);

        databing.executePendingBindings();
    }

    @Override
    public int getItemCount() {
        return list == null ? 0 : list.size();
    }

    static class CheckAdapterVH extends RecyclerView.ViewHolder {
        private static ItemStoreCheckLocationBinding binding;
        public CheckAdapterVH(ItemStoreCheckLocationBinding binding) {
            super(binding.getRoot());
            this.binding = binding;
        }


    }



}
