package com.example.haiwei_mom.adapter.check;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.recyclerview.widget.RecyclerView;

import com.example.haiwei_mom.BR;
import com.example.haiwei_mom.R;
import com.example.haiwei_mom.adapter.ItemClickCall;
import com.example.haiwei_mom.databinding.ItemCheckSelectBinding;
import com.example.haiwei_mom.data.check.CheckResult;

import java.util.List;

/**
 * @author wanghao
 * @date 2024/1/31  15:18
 */
public class CheckSelectAdapter extends RecyclerView.Adapter<CheckSelectAdapter.MyViewHolder> {
    private List<CheckResult> list;
    private Context context;
    private LayoutInflater inflater;
    private ItemClickCall clickCall;
    public CheckSelectAdapter(Context context, ItemClickCall clickCall) {
        this.context = context;
        this.clickCall = clickCall;
        inflater = LayoutInflater.from(context);
    }

    public void setList(List<CheckResult> list) {
        this.list = list;
    }

    @NonNull
    @Override
    public MyViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        ItemCheckSelectBinding binding = DataBindingUtil.inflate(inflater, R.layout.item_check_select, parent, false);
        return new MyViewHolder(binding);
    }

    @Override
    public void onBindViewHolder(@NonNull MyViewHolder holder, int position) {
        var outstock = list.get(position);
        var binding = holder.binding;
        binding.setVariable(BR.vm,outstock);
        binding.checkSelectClick.setOnClickListener(v -> clickCall.onClick(position));
    }

    @Override
    public int getItemCount() {
        return list==null?0:list.size();
    }

    class MyViewHolder extends RecyclerView.ViewHolder {
        private ItemCheckSelectBinding binding;

        public MyViewHolder(ItemCheckSelectBinding binding) {
            super(binding.getRoot());
            this.binding = binding;
        }


    }
}
