package com.example.haiwei_mom.adapter.check;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.recyclerview.widget.RecyclerView;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.databinding.ItemCheck1Binding;
import com.example.haiwei_mom.databinding.ItemCheck2Binding;
import com.example.haiwei_mom.data.check.CheckResultDetal;

import java.util.List;

/**
 * @author wanghao
 * @date 2024/3/1  17:23
 */
public class CheckWorkAdapter extends RecyclerView.Adapter<RecyclerView.ViewHolder> {
    private List<CheckResultDetal> list;
    private Context context;
    private boolean enabledState;

    public void setEnabledState(boolean enabledState) {
        this.enabledState = enabledState;
    }

    public CheckWorkAdapter(Context context) {
        this.context = context;
    }

    public void setList(List<CheckResultDetal> list) {
        this.list = list;
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        var inflater = LayoutInflater.from(context);
        if (viewType==1){
            ItemCheck1Binding binding = DataBindingUtil.inflate(inflater, R.layout.item_check_1, parent, false);
            return new MyHolder1(binding);
        } else {
            ItemCheck2Binding binding = DataBindingUtil.inflate(inflater, R.layout.item_check_2, parent, false);
            return new MyHolder2(binding);
        }

    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        var checkResultDetal = list.get(position);
        checkResultDetal.setIndex(position+1);
        if (holder instanceof MyHolder1){
            MyHolder1 holder1= (MyHolder1) holder;
            holder1.binding.setItem(checkResultDetal);
            holder1.binding.setEnabledState(enabledState);
            holder1.binding.executePendingBindings();
        }else {
            MyHolder2 holder2= (MyHolder2) holder;
            holder2.binding.setItem(checkResultDetal);
            holder2.binding.setEnabledState(enabledState);
            holder2.binding.executePendingBindings();
        }
    }

    @Override
    public int getItemCount() {
        return list==null?0:list.size();
    }

    @Override
    public int getItemViewType(int position) {
        return Integer.parseInt(list.get(position).getCheckProjectProperty());
    }

    class MyHolder1 extends RecyclerView.ViewHolder {
        private ItemCheck1Binding binding;

        public MyHolder1(@NonNull ItemCheck1Binding binding) {
            super(binding.getRoot());
            this.binding = binding;
        }
    }

    class MyHolder2 extends RecyclerView.ViewHolder {
        private ItemCheck2Binding binding;

        public MyHolder2(@NonNull ItemCheck2Binding binding) {
            super(binding.getRoot());
            this.binding = binding;
        }
    }


}
