package com.example.haiwei_mom.adapter.device;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.recyclerview.widget.RecyclerView;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.databinding.ItemDeviceInspection1Binding;
import com.example.haiwei_mom.databinding.ItemDeviceInspection2Binding;
import com.example.haiwei_mom.data.device.DeviceInspectionItem;

import java.util.List;

/**
 * @author wanghao
 * @date 2024/3/1  17:23
 */
public class DeviceInspectionInfoAdapter extends RecyclerView.Adapter<RecyclerView.ViewHolder> {
    private List<DeviceInspectionItem> list;
    private Context context;
   private LayoutInflater inflater;
    public DeviceInspectionInfoAdapter(Context context,List<DeviceInspectionItem> list) {
        this.context = context;
        inflater = LayoutInflater.from(context);
        this.list = list;
    }



    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {


        if (viewType==1){
            ItemDeviceInspection1Binding binding = DataBindingUtil.inflate(inflater, R.layout.item_device_inspection_1, parent, false);
            return new MyHolder1(binding);
        } else {
            ItemDeviceInspection2Binding binding = DataBindingUtil.inflate(inflater, R.layout.item_device_inspection_2, parent, false);
            return new MyHolder2(binding);
        }

    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        var checkResultDetal = list.get(position);
        checkResultDetal.setIndex(position+1);
        if (holder instanceof MyHolder1){
            MyHolder1 holder1= (MyHolder1) holder;
            holder1.binding.setItem(checkResultDetal);
            holder1.binding.executePendingBindings();
        }else {
            MyHolder2 holder2= (MyHolder2) holder;
            holder2.binding.setItem(checkResultDetal);
            holder2.binding.executePendingBindings();
        }
    }

    @Override
    public int getItemCount() {
        return list==null?0:list.size();
    }

    @Override
    public int getItemViewType(int position) {
        return Integer.parseInt(list.get(position).getInspectProjectProperty());
    }

    class MyHolder1 extends RecyclerView.ViewHolder {
        private ItemDeviceInspection1Binding binding;

        public MyHolder1(@NonNull ItemDeviceInspection1Binding binding) {
            super(binding.getRoot());
            this.binding = binding;
        }
    }

    class MyHolder2 extends RecyclerView.ViewHolder {
        private ItemDeviceInspection2Binding binding;

        public MyHolder2(@NonNull ItemDeviceInspection2Binding binding) {
            super(binding.getRoot());
            this.binding = binding;
        }
    }


}
