package com.example.haiwei_mom.adapter.device;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.recyclerview.widget.RecyclerView;

import com.example.haiwei_mom.BR;
import com.example.haiwei_mom.R;
import com.example.haiwei_mom.adapter.ItemClickCall;
import com.example.haiwei_mom.databinding.ItemDeviceInspectionBinding;
import com.example.haiwei_mom.data.device.DeviceInspectionDetail;

import java.util.List;

/**
 * @author wanghao
 * @date 2024/1/31  15:18
 */
public class DeviceInspectiontAdapter extends RecyclerView.Adapter<DeviceInspectiontAdapter.MyViewHolder> {
    private List<DeviceInspectionDetail> list;
    private Context context;
    private LayoutInflater inflater;
    private ItemClickCall clickCall;
    public DeviceInspectiontAdapter(Context context, ItemClickCall clickCall) {
        this.context = context;
        this.clickCall = clickCall;
        inflater = LayoutInflater.from(context);
    }

    public void setList(List<DeviceInspectionDetail> list) {
        this.list = list;
    }

    @NonNull
    @Override
    public MyViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        ItemDeviceInspectionBinding binding = DataBindingUtil.inflate(inflater, R.layout.item_device_inspection, parent, false);
        return new MyViewHolder(binding);
    }

    @Override
    public void onBindViewHolder(@NonNull MyViewHolder holder, int position) {
        var DeviceInspectionDetail = list.get(position);
        var binding = holder.binding;
        binding.setVariable(BR.vm,DeviceInspectionDetail);
        binding.deviceInspectionClick.setOnClickListener(v -> clickCall.onClick(position));
    }

    @Override
    public int getItemCount() {
        return list==null?0:list.size();
    }

    class MyViewHolder extends RecyclerView.ViewHolder {
        private ItemDeviceInspectionBinding binding;

        public MyViewHolder(ItemDeviceInspectionBinding binding) {
            super(binding.getRoot());
            this.binding = binding;
        }


    }
}
