package com.example.haiwei_mom.adapter.device;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.recyclerview.widget.RecyclerView;

import com.example.haiwei_mom.BR;
import com.example.haiwei_mom.R;
import com.example.haiwei_mom.databinding.ItemDeviceRepairBinding;
import com.example.haiwei_mom.data.device.DeviceRepair;

import java.util.List;

/**
 * @author wanghao
 * @date 2024/1/31  15:18
 */
public class DeviceRepairListAdapter extends RecyclerView.Adapter<DeviceRepairListAdapter.MyViewHolder> {
    private List<DeviceRepair> list;
    private Context context;
    private LayoutInflater inflater;
    private ItemClickCall clickCall;
    public DeviceRepairListAdapter(Context context, ItemClickCall clickCall) {
        this.context = context;
        this.clickCall = clickCall;
        inflater = LayoutInflater.from(context);
    }

    public void setList(List<DeviceRepair> list) {
        this.list = list;
    }

    @NonNull
    @Override
    public MyViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        ItemDeviceRepairBinding binding = DataBindingUtil.inflate(inflater, R.layout.item_device_repair, parent, false);
        return new MyViewHolder(binding);
    }

    @Override
    public void onBindViewHolder(@NonNull MyViewHolder holder, int position) {
        var outstock = list.get(position);

        var binding = holder.binding;
        binding.setVariable(BR.vm,outstock);
        binding.deviceRepairModify.setOnClickListener(v -> clickCall.clickItemForModify(position));
        binding.deviceRepairSelect.setOnClickListener(v -> clickCall.clickItemForSelect(position));
    }

    @Override
    public int getItemCount() {
        return list==null?0:list.size();
    }

    class MyViewHolder extends RecyclerView.ViewHolder {
        private ItemDeviceRepairBinding binding;

        public MyViewHolder(ItemDeviceRepairBinding binding) {
            super(binding.getRoot());
            this.binding = binding;
        }


    }

    public interface ItemClickCall{
       void clickItemForModify(int index);
       void clickItemForSelect(int index);
    }
}
