package com.example.haiwei_mom.adapter.device;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.recyclerview.widget.RecyclerView;

import com.example.haiwei_mom.BR;
import com.example.haiwei_mom.R;
import com.example.haiwei_mom.adapter.ItemClickCall;
import com.example.haiwei_mom.databinding.ItemRepairPartBinding;
import com.example.haiwei_mom.data.device.DeviceRepairPart;

import java.util.List;

/**
 * @author wanghao
 * @date 2024/1/31  15:18
 */
public class DeviceRepairPartAdapter extends RecyclerView.Adapter<DeviceRepairPartAdapter.MyViewHolder> {
    private List<DeviceRepairPart> list;
    private Context context;
    private LayoutInflater inflater;
    private ItemClickCall clickCall;
    public DeviceRepairPartAdapter(Context context, ItemClickCall clickCall) {
        this.context = context;
        this.clickCall = clickCall;
        inflater = LayoutInflater.from(context);
    }

    public void setList(List<DeviceRepairPart> list) {
        this.list = list;
    }

    @NonNull
    @Override
    public MyViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        ItemRepairPartBinding binding = DataBindingUtil.inflate(inflater, R.layout.item_repair_part, parent, false);
        return new MyViewHolder(binding);
    }

    @Override
    public void onBindViewHolder(@NonNull MyViewHolder holder, int position) {
        var DeviceInspectionDetail = list.get(position);
        var binding = holder.binding;
        binding.setVariable(BR.vm,DeviceInspectionDetail);
        binding.pairDelete.setOnClickListener(v -> clickCall.onClick(position));
    }

    @Override
    public int getItemCount() {
        return list==null?0:list.size();
    }

    class MyViewHolder extends RecyclerView.ViewHolder {
        private ItemRepairPartBinding binding;

        public MyViewHolder(ItemRepairPartBinding binding) {
            super(binding.getRoot());
            this.binding = binding;
        }


    }
}
