package com.example.haiwei_mom.adapter.device;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.recyclerview.widget.RecyclerView;

import com.example.haiwei_mom.BR;
import com.example.haiwei_mom.R;
import com.example.haiwei_mom.databinding.ItemMaintainInfoProjectBinding;
import com.example.haiwei_mom.data.device.MaintainProject;

import java.util.List;

/**
 * @author wanghao
 * @date 2024/1/31  15:18
 */
public class MaintainProjectAdapter extends RecyclerView.Adapter<MaintainProjectAdapter.MyViewHolder> {
    private List<MaintainProject> list;
    private Context context;
    private LayoutInflater inflater;
    public MaintainProjectAdapter(Context context) {
        this.context = context;
        inflater = LayoutInflater.from(context);
    }

    public void setList(List<MaintainProject> list) {
        this.list = list;
    }

    @NonNull
    @Override
    public MyViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        ItemMaintainInfoProjectBinding binding = DataBindingUtil.inflate(inflater, R.layout.item_maintain_info_project, parent, false);
        return new MyViewHolder(binding);
    }

    @Override
    public void onBindViewHolder(@NonNull MyViewHolder holder, int position) {
        var been = list.get(position);
        var binding = holder.binding;
        binding.setVariable(BR.item,been);
    }

    @Override
    public int getItemCount() {
        return list==null?0:list.size();
    }

    class MyViewHolder extends RecyclerView.ViewHolder {
        private ItemMaintainInfoProjectBinding binding;

        public MyViewHolder(ItemMaintainInfoProjectBinding binding) {
            super(binding.getRoot());
            this.binding = binding;
        }


    }
}
