package com.example.haiwei_mom.data;


import androidx.databinding.BaseObservable;

import java.util.Date;
import java.util.Observable;

/**
 * 装车架子信息对象 wms_psm_in_load
 *
 * @author LionLi
 * @date 2025-01-15
 */

public class WmsPsmInLoad extends BaseObservable {


    public void setToolingBarcode(String toolingBarcode) {
        this.toolingBarcode = toolingBarcode;
        notifyChange();
    }

    /**
     * 工装条码
     */
    private String toolingBarcode;

    private Long inLoadId;

    /**
     * 物料ID
     */
    private Long materialId;

    /**
     * 轮胎规格
     */
    private String materialSpe;

    /**
     * 品级编号
     */
    private String checkGradeCode;

    /**
     * 装载数量
     */
    private Long loadAmount;
    private String materialCode;

    public String getToolingBarcode() {
        return toolingBarcode;
    }

    public Long getMaterialId() {
        return materialId;
    }

    public String getMaterialSpe() {
        return materialSpe;
    }

    public String getCheckGradeCode() {
        return checkGradeCode;
    }

    public Long getLoadAmount() {
        return loadAmount;
    }

    public String getMaterialCode() {
        return materialCode;
    }


    /**
     * 库位条码
     */
    private String storePlaceCode;

    public String getStorePlaceCode() {
        return storePlaceCode;
    }

    public void setStorePlaceCode(String storePlaceCode) {
        this.storePlaceCode = storePlaceCode;
        notifyChange();
    }
}
