package com.example.haiwei_mom.device;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListPopupWindow;

import androidx.databinding.DataBindingUtil;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.adapter.check.DisposalFileAdapter;
import com.example.haiwei_mom.base.BaseActivity;
import com.example.haiwei_mom.base.MyRecultCall;
import com.example.haiwei_mom.base.MyResult;
import com.example.haiwei_mom.databinding.ActivityBxBinding;
import com.example.haiwei_mom.dialog.ImgDialog;
import com.example.haiwei_mom.data.check.CheckInstanceFiles;
import com.example.haiwei_mom.data.device.BxSubmitBeen;
import com.example.haiwei_mom.data.device.DeviceBeen;
import com.example.haiwei_mom.data.device.Dict;
import com.example.haiwei_mom.data.device.Outsourcing;
import com.example.haiwei_mom.uitls.SharedPreferencesUtils;
import com.google.gson.reflect.TypeToken;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

/**
 * 故障报修
 */
public class BxActivity extends BaseActivity implements DisposalFileAdapter.ItemClickCall {
    private DisposalFileAdapter adapter;
    private List<CheckInstanceFiles> filesList;
    private List<File> files;
    private BxSubmitBeen been;
    private ActivityBxBinding binding;
    private ListPopupWindow lpw;
    private ListPopupWindow deviceCodeLpw;
    private ArrayList<String> designList;
    private ImgDialog imgDialog;
    private boolean aBoolean;

    @SuppressLint("ClickableViewAccessibility")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = DataBindingUtil.setContentView(this, R.layout.activity_bx);
        adapter = new DisposalFileAdapter(this, this);
        filesList = new ArrayList<>();
        files = new ArrayList<>();
        adapter.setList(filesList);
        binding.setAdapter1(adapter);
        been = new BxSubmitBeen();
        outStrRequest();
        binding.setVm(been);
        initSlectLpw();
        initRequestLpw();
        imgDialog = new ImgDialog(this);

    }

    private void initSlectLpw() {
        deviceCodeLpw = new ListPopupWindow(this);
        deviceCodeLpw.setAnchorView(binding.selectNameView);
        deviceCodeLpw.setOnItemClickListener((parent, view, position, id) -> {
            var deviceBeen = list.get(position);
            been.setDeviceld(deviceBeen.getDeviceId());
            binding.setDevice(deviceBeen);
            aBoolean = true;
            deviceCodeLpw.dismiss();
        });
    }

    private void initRequestLpw() {
        initRequest("dms_fault_type");
        lpw = new ListPopupWindow(this);
        lpw.setAnchorView(binding.bxDesOpe);
        designList = new ArrayList<>();
        aBoolean = false;
        initRequest("dms_device_design_operations");
        lpw.setOnItemClickListener((parent, view, position, id) -> {
            var designOperations = been.getDesignOperations();
            var addStr = designList.get(position);
            if (designOperations != null && designOperations.contains(addStr)) {
                String tagStr = null;
                if (designOperations.indexOf(addStr) == 0) {
                    tagStr = addStr + ",";
                } else {
                    tagStr = "," + addStr;
                }
                designOperations = designOperations.replace(tagStr, "")
                        .replace(addStr, "");
                been.setDesignOperations(designOperations);
            } else {
                been.setDesignOperations(Optional.ofNullable(designOperations).map(t -> t.isEmpty() ? t : t + ",").orElse("") + addStr);
            }

            lpw.dismiss();
        });
        binding.bxDesOpe.setOnTouchListener((v, event) -> {
            int clickX = (int) event.getX();
            if (clickX > 450) {
                lpw.show();
            }
            return true;
        });
    }


    // 查询外协
    private void outStrRequest() {
        OkGo.<MyResult>get(url + "/dms/mobile/getOutsrcInfos").tag(this)
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            List<Outsourcing> outsourcingList = gson.fromJson(body.getData().toString(), new TypeToken<List<Outsourcing>>() {
                            }.getType());
                            been.setOutsourcingList(outsourcingList);
                            return;
                        }
                    }
                });
    }

    // 维修
    private void initRequest(String uri) {
        OkGo.<MyResult>get(url + "/dms/mobile/dict/type/" + uri).tag(this)
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            List<Dict> list = gson.fromJson(body.getData().toString(), new TypeToken<List<Dict>>() {
                            }.getType());

                            if (uri.equals("dms_fault_type")) {
                                been.setFaultTypeList(list);
                            } else {
                                list.forEach(t -> designList.add(t.getDictLabel()));
                                lpw.setAdapter(new ArrayAdapter<>(context,
                                        androidx.appcompat.R.layout.support_simple_spinner_dropdown_item,
                                        designList));
                            }
                        }
                    }
                });

    }

    @SuppressLint("NotifyDataSetChanged")
    @Override
    public void onClick(int position, boolean type) {
        if (type) {
            imgDialog.setRawReturn(filesList.get(position).getFaultFile());
            return;
        }
        filesList.remove(position);
        files.remove(position);
        adapter.notifyDataSetChanged();
    }

    public void bxTackphoto(View view) {
        try {
            teke_photo();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }


    }


    @SuppressLint("NotifyDataSetChanged")
    @Override
    public void tekePhotoResult(String fileUrl, File file) {
        super.tekePhotoResult(fileUrl, file);
        CheckInstanceFiles checkInstanceFiles = new CheckInstanceFiles();
        checkInstanceFiles.setFaultFile(fileUrl);
        checkInstanceFiles.setState(true);
        filesList.add(checkInstanceFiles);
        adapter.notifyDataSetChanged();
        files.add(file);
    }

    private List<DeviceBeen> list;

    // 模糊查询
    public void bxSelect(View view) {
        OkGo.<MyResult>get(url + "/dms/mobile/likeDeviceName").tag(this)
                .params("deviceName", been.getSelectName())
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            list = gson.fromJson(body.getData().toString(), new TypeToken<List<DeviceBeen>>() {
                            }.getType());
                            if (list == null || list.isEmpty()) {
                                aBoolean = false;
                                return;
                            }
                            List<String> tagList = new ArrayList<>(list.size());
                            list.forEach(deviceBeen -> tagList.add(deviceBeen.getDeviceName()));
                            deviceCodeLpw.setAdapter(new ArrayAdapter<>(context,
                                    androidx.appcompat.R.layout.support_simple_spinner_dropdown_item,
                                    tagList));
                            deviceCodeLpw.show();

                        } else {
                            binding.setDevice(null);
                        }
                    }
                });
    }

    public void bxSelectCode(String code) {
        OkGo.<MyResult>get(url + "/dms/mobile/getDeviceByDeviceCode/" + code).tag(this)
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        aBoolean = (body.getCode() == 200);
                        if (aBoolean) {
                            DeviceBeen deviceBeen = gson.fromJson(body.getData().toString(), DeviceBeen.class);
                            been.setDeviceld(deviceBeen.getDeviceId());
                            binding.setDevice(deviceBeen);
                        } else {
                            binding.setDevice(null);
                        }
                    }
                });
    }

    public void bxSubmit(View view) {
        if (!aBoolean) {
            myToastUitls.show("数据异常，提交失败");
            return;
        }
        OkGo.<MyResult>post(url + "/dms/mobile/insertFaultInstsanceActivity")
                .params("deviceId", been.getDeviceld())
                .params("faultType", been.getFaultType())
                .params("faultDescription", been.getFaultDescription())
                .params("designOperations", been.getDesignOperations())
                .params("repairType", been.getRepairType())
                .params("outsrcId", been.getOutsrcld())
                .addFileParams("files", files)
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            finish();
                        }
                        myToastUitls.show(body.getMsg());
                    }
                });
    }
}