package com.example.haiwei_mom.device;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.os.Bundle;

import androidx.databinding.DataBindingUtil;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.adapter.device.DeviceRepairListAdapter;
import com.example.haiwei_mom.base.BaseActivity;
import com.example.haiwei_mom.base.MyRecultCall;
import com.example.haiwei_mom.base.MyResult;
import com.example.haiwei_mom.databinding.ActivityDeviceRepairListBinding;
import com.example.haiwei_mom.data.device.DeviceRepair;
import com.example.haiwei_mom.uitls.SharedPreferencesUtils;
import com.google.gson.reflect.TypeToken;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.List;

public class DeviceRepairListActivity extends BaseActivity implements DeviceRepairListAdapter.ItemClickCall {
    private DeviceRepairListAdapter adapter;
    private List<DeviceRepair> list;
    private Intent intent;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        ActivityDeviceRepairListBinding binding = DataBindingUtil.setContentView(this, R.layout.activity_device_repair_list);
        adapter = new DeviceRepairListAdapter(this, this);
        binding.setAdapter(adapter);
        intent=new Intent(this, DeviceRepairInfoActivity.class);
    }

    @Override
    protected void onResume() {
        super.onResume();
        OkGo.<MyResult>get(url + "/dms/mobile/getBillsFaultInstances")
                .execute(new MyRecultCall(dialog, this) {
                    @SuppressLint("NotifyDataSetChanged")
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getTotal() == 0) {
                            myToastUitls.show( body.getCode()==200?"暂无记录":body.getMsg() );
                            return;
                        }
                        list=gson.fromJson(gson.toJson(body.getRows()),new TypeToken<List<DeviceRepair>>(){}.getType());
                        adapter.setList(list);
                        adapter.notifyDataSetChanged();
                    }
                });
    }

    @Override
    public void clickItemForModify(int index) {
        var repairInstanceId = list.get(index).getRepairInstanceId();
        // Toast.makeText(context, repairInstanceId+"", Toast.LENGTH_SHORT).show();
        OkGo.<MyResult>get(url+"/dms/mobile/getBillsFaultInstanceByRepairInstanceId/"+repairInstanceId)
                .execute(new MyRecultCall(dialog,this){
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode()==200){
                            intent.putExtra("json",body.getData().toString());
                            intent.putExtra("activityType",true);
                            startActivity(intent);
                            return;
                        }
                        String msg = body.getMsg();
                        myToastUitls.show(msg==null?"服务器500":msg );
                    }
                });
    }

    @Override
    public void clickItemForSelect(int index) {
        var repairInstanceId = list.get(index).getRepairInstanceId();
        OkGo.<MyResult>get(url+"/dms/mobile/getBillsFaultInstance4Repair/"+repairInstanceId)
                .execute(new MyRecultCall(dialog,this){
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode()==200){
                            intent.putExtra("json",body.getData().toString());
                            intent.putExtra("activityType",false);
                            startActivity(intent);
                            return;
                        }
                        myToastUitls.show( body.getMsg());
                    }
                });
    }
}