package com.example.haiwei_mom.device;

import android.content.Intent;
import android.os.Bundle;

import androidx.databinding.DataBindingUtil;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.adapter.ItemClickCall;
import com.example.haiwei_mom.adapter.device.MaintainAdapter;
import com.example.haiwei_mom.base.BaseActivity;
import com.example.haiwei_mom.base.MyRecultCall;
import com.example.haiwei_mom.base.MyResult;
import com.example.haiwei_mom.databinding.ActivityMaintainBinding;
import com.example.haiwei_mom.data.device.MaintainBeen;
import com.example.haiwei_mom.data.device.MaintainDetail;
import com.example.haiwei_mom.uitls.SharedPreferencesUtils;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.List;

public class MaintainActivity extends BaseActivity implements ItemClickCall {
    private MaintainAdapter adapter;
    private List<MaintainDetail> list;
    private ActivityMaintainBinding binding;
    private Intent intent;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = DataBindingUtil.setContentView(this, R.layout.activity_maintain);
        adapter = new MaintainAdapter(this, this);
        binding.setAdapter(adapter);
        intent=new Intent(this,MaintainInfoActivity.class);

    }

    @Override
    protected void onResume() {
        super.onResume();
        initRequest();
    }

    private void initRequest() {
        OkGo.<MyResult>get(url + "/dms/mobile/getNewestMaintInstance").tag(this)
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            MaintainBeen been = gson.fromJson(body.getData().toString(), MaintainBeen.class);

                            binding.setVm(been);
                            list = been.getDmsBillsMaintDetailList();
                            adapter.setList(list);
                            adapter.notifyDataSetChanged();
                        }
                    }
                });
    }

    @Override
    public void onClick(int position) {
        var maintainDetail = list.get(position);
        intent.putExtra("json", gson.toJson(maintainDetail));
        startActivity(intent);


    }
}