package com.example.haiwei_mom.dialog;

import android.app.Dialog;
import android.content.Context;
import android.view.LayoutInflater;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.databinding.DialogAddPartBinding;
import com.example.haiwei_mom.data.device.DeviceRepairPart;

/**
 * @author wanghao
 * @date 2024/2/22  11:07
 */
public class RepairPartAddDialog extends Dialog {


    private RepairPartAddDialogCall stockReturnDialogCall;
    private Context context;


    public RepairPartAddDialog(@NonNull Context context, RepairPartAddDialogCall call) {
        super(context, R.style.dialog_style);
        this.context = context;
        this.stockReturnDialogCall = call;
        DialogAddPartBinding binding = DataBindingUtil.inflate(LayoutInflater.from(context), R.layout.dialog_add_part, null, false);
        setContentView(binding.getRoot());
        DeviceRepairPart  deviceRepairPart=new DeviceRepairPart();
        binding.setVm(deviceRepairPart);
        binding.dialogAddpartFalse.setOnClickListener(v -> dismiss());
        binding.dialogAddpartTrue.setOnClickListener(v -> call.returnResult(deviceRepairPart));
    }

    public interface RepairPartAddDialogCall {
        void returnResult(DeviceRepairPart deviceRepairPart);
    }

}
