package com.example.haiwei_mom.qm;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Toast;

import androidx.databinding.DataBindingUtil;

import com.bigkoo.pickerview.builder.OptionsPickerBuilder;
import com.bigkoo.pickerview.listener.OnOptionsSelectListener;
import com.bigkoo.pickerview.view.OptionsPickerView;
import com.example.haiwei_mom.R;
import com.example.haiwei_mom.adapter.CheckAdapter;
import com.example.haiwei_mom.base.BaseActivity;
import com.example.haiwei_mom.base.MyRecultCall;
import com.example.haiwei_mom.base.MyResult;
import com.example.haiwei_mom.databinding.ActivityCheckBinding;
import com.example.haiwei_mom.qm.data.CheckViewModel;
import com.example.haiwei_mom.qm.data.DefectBeen;
import com.example.haiwei_mom.qm.data.QcTaskInfo;
import com.example.haiwei_mom.uitls.SharedPreferencesUtils;
import com.google.gson.reflect.TypeToken;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.ArrayList;
import java.util.List;

import okhttp3.RequestBody;

public class CheckActivity extends BaseActivity implements CheckAdapter.CheckItemClickCall/*, AdapterView.OnItemClickListener*/, OnOptionsSelectListener/*, RepaitSubmintInfoAdapter.CheckItemClickCall*/ {
    private CheckViewModel checkViewModel;

    // private RepairSubmintInfoDialog tipDialog;
    private CheckAdapter checkAdapter;
    private List<DefectBeen> list;
    private List<DefectBeen> submitList;// 提交缺陷列表
    private OptionsPickerView opv;
    private List<String> options1;
    private List<List<String>> options2;
    private List<List<List<String>>> options3;
    private List<DefectBeen> topDefects;
    private String stationCode;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        ActivityCheckBinding binding = DataBindingUtil.setContentView(this, R.layout.activity_check);
        checkViewModel = new CheckViewModel();
        binding.setVm(checkViewModel);
        checkAdapter = new CheckAdapter(this, this);
        submitList = new ArrayList<>();
        checkAdapter.setList(submitList);
        binding.recyclerView.setAdapter(checkAdapter);
        binding.checkGoodsCode.setOnEditorActionListener((v, actionId, event) -> {
            selectGoodsInfo(v.getText().toString());
            return true;
        });


    }
    @Override
    public void getScannerData(String code) {
        super.getScannerData(code);
        selectGoodsInfo(code);

    }
    // 查询物料
    public void selectGoodsInfo(String code) {
        OkGo.<MyResult>get(url + "/api/pdaApi/getMaterialInfo").tag(this)
                .params("code", code)
                // .params("station", stationCode)
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var result = response.body();
                        if (result.getCode() == 200) {
                            QcTaskInfo qcTaskInfo=gson.fromJson(result.getDataJson(),QcTaskInfo.class);
                            checkViewModel.setName(qcTaskInfo.getMaterialName());
                            initOptionpb( qcTaskInfo.getOperation());
                          /*  checkViewModel.setName(result.getMsg());
                            topDefects = gson.fromJson(gson.toJson(result.getData()), new TypeToken<List<DefectBeen>>() {
                            }.getType());
                            if (topDefects == null || topDefects.isEmpty()) {
                                Toast.makeText(CheckActivity.this, "本工位无需检查返修情况", Toast.LENGTH_SHORT).show();
                                return;
                            }
                            checkViewModel.setButtonVisbleState(true);*/
                            // tipDialog.setList(topDefects);
                            // tipDialog.show();

                            return;

                        }
                        myToastUitls.show(result.getMsg());

                    }
                });

    }


    // 弹出选择框
    public void checkSelect(View view) {
        if (options1==null ||list.isEmpty()) return;
        opv.show();
    }




    public void checkSubmint(View view) {
        if (checkViewModel.getName() == null || checkViewModel.getName().isEmpty()) return;
        Toast.makeText(context, "质检完成", Toast.LENGTH_SHORT).show();
        finish();
       /* checkViewModel.setList(submitList);
        checkViewModel.setMeasure(submitList.isEmpty() ? "3" : "1");
        checkViewModel.setUserName(SharedPreferencesUtils.getstring("loginName", "pda01"));
        checkViewModel.setTeamCode(SharedPreferencesUtils.getstring("teamCode", null));
        OkGo.<MyResult>post(url + "/api/checkSubmit").tag(this).upRequestBody(RequestBody.create(JSON, gson.toJson(checkViewModel))).execute(new MyRecultCall(dialog, this) {
            @Override
            public void onSuccess(Response<MyResult> response) {
                super.onSuccess(response);
                var result = response.body();
                if (result.getCode() == 200) {
                    Toast.makeText(CheckActivity.this, "提交成功", Toast.LENGTH_SHORT).show();
                    checkViewModel.setCode(null);
                    checkViewModel.setName(null);
                    checkViewModel.setDefect(null);
                    checkViewModel.setButtonVisbleState(false);
                    submitList.clear();
                    checkAdapter.notifyDataSetChanged();
                    // initStationSum();
                } else {
                    Toast.makeText(CheckActivity.this, result.getMsg(), Toast.LENGTH_SHORT).show();
                }
            }
        });*/
    }

    // 删除缺陷
    @Override
    public void onClick(int positon) {
        Log.e("TAG", "列表点击:" + positon);
        submitList.remove(positon);
        checkAdapter.notifyDataSetChanged();
    }

    // 初始化-联动选择
    private void initOptionpb(String stationCode) {
        opv = new OptionsPickerBuilder(this, this).build();
        OkGo.<MyResult>get(url + "/api/pdaApi/getDefectDetail")
                // .params("defectType", "BZP_DEFECT")
                .params("defectType", stationCode).execute(new MyRecultCall(dialog, this) {
            @Override
            public void onSuccess(Response<MyResult> response) {
                super.onSuccess(response);
                var body = response.body();
                Log.e("TAG", "onSuccess:" + body.toString());
                if (body.getCode() == 200) {
                    Toast.makeText(CheckActivity.this, "请求成功", Toast.LENGTH_SHORT).show();
                    list = gson.fromJson(gson.toJson(body.getData()), new TypeToken<List<DefectBeen>>() {
                    }.getType());
                    if (list == null || list.isEmpty()) {
                        Toast.makeText(CheckActivity.this, "缺陷列表没有维护", Toast.LENGTH_SHORT).show();
                        return;
                    }
                    options1 = new ArrayList<>(list.size());
                    // options2 = new ArrayList<>();
                    // options3 = new ArrayList<>();
                    list.forEach(defect -> {
                        options1.add(defect.getDefectDesc());
                    //     String materialCategories = defect.getMaterialCategories();
                    //     String materialSubclass = defect.getMaterialSubclass();
                    //     String qualityDefectName = defect.getQualityDefectName();
                    //
                    //     if (!options1.contains(materialCategories)) {
                    //         options1.add(materialCategories);
                    //     }
                    //     int index1 = options1.indexOf(materialCategories);
                    //     if (options2.size() <= index1) {
                    //         options2.add(new ArrayList<>());
                    //     }
                    //     if (!options2.get(index1).contains(materialSubclass)) {
                    //         options2.get(index1).add(materialSubclass);
                    //     }
                    //     int index2 = options2.get(index1).indexOf(materialSubclass);
                    //     if (options3.size() <= index1) {
                    //         options3.add(new ArrayList<>());
                    //     }
                    //     if (options3.get(index1).size() <= index2) {
                    //         options3.get(index1).add(new ArrayList<>());
                    //     }
                    //     if (!options3.get(index1).get(index2).contains(qualityDefectName)) {
                    //         options3.get(index1).get(index2).add(qualityDefectName);
                    //     }
                    });
                    // opv.setPicker(options1, options2, options3);
                    opv.setPicker(options1);
                } else {
                    Toast.makeText(CheckActivity.this, body.getMsg(), Toast.LENGTH_SHORT).show();
                }
            }

        });
    }

    // 三联添加
    @Override
    public void onOptionsSelect(int options1, int options2, int options3, View v) {
        String defectName = this.options1.get(options1);
        checkViewModel.setDefect(defectName);
        DefectBeen defectBeen = new DefectBeen();
        defectBeen.setDefectDesc(defectName);
        DefectBeen defectBeen1 = list.get(list.indexOf(defectBeen));
        if (submitList.contains(defectBeen1)) {
            Toast.makeText(this, "已经添加了", Toast.LENGTH_SHORT).show();
            return;
        }
        submitList.add(defectBeen1);
        checkAdapter.notifyDataSetChanged();
    }

    // 返修添加提交数据中
    // @Override
    // public void submintRepair(int positon) {
    //     DefectBeen defectBeen = topDefects.get(positon);
    //     if (submitList.contains(defectBeen)) {
    //         Toast.makeText(this, "已经添加了", Toast.LENGTH_SHORT).show();
    //         return;
    //     }
    //     Log.e("TAG", "返修提交的ID:" + defectBeen.getObjId());
    //     submitList.add(defectBeen);
    //     checkAdapter.notifyDataSetChanged();
    //     Toast.makeText(this, "添加成功", Toast.LENGTH_SHORT).show();
    // }
}