package com.example.haiwei_mom.wms.product;

import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.widget.EditText;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.base.BaseActivity;
import com.example.haiwei_mom.base.MyRecultCall;
import com.example.haiwei_mom.base.MyResult;
import com.example.haiwei_mom.data.WmsPsmInLoad;
import com.example.haiwei_mom.databinding.ActivityProductInBinding;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import okhttp3.RequestBody;

public class ProductInActivity extends BaseActivity implements View.OnFocusChangeListener {
    private WmsPsmInLoad wmsPsmInLoad;
   private EditText productInCode;
   private  EditText productInLocation;private ActivityProductInBinding binding;
    @SuppressLint("ClickableViewAccessibility")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        binding = DataBindingUtil.setContentView(this, R.layout.activity_product_in);
        productInCode = binding.productInCode;
        productInCode.setOnFocusChangeListener(this);

        productInLocation = binding.productInLocation;
        productInLocation   .setOnFocusChangeListener(this);
        productInCode.setOnTouchListener((v, event) -> {
            final int DRAWABLE_RIGHT = 2;
            if (event.getAction() == MotionEvent.ACTION_UP) {
                // 获取触摸的位置
                int x = (int) event.getX();
                // 获取图标的边界
                int drawableRightWidth = productInCode.getCompoundDrawables()[DRAWABLE_RIGHT].getBounds().width();
                int drawableRightStart = (int) (productInCode.getWidth() - productInCode.getPaddingRight() - drawableRightWidth);
                Log.e("TAG", "onCreate1:" + drawableRightWidth);
                Log.e("TAG", "onCreate2:" + drawableRightStart);
                // 判断是否点击了右侧图标
                if (x >= drawableRightStart && x <= (productInCode.getWidth() - productInCode.getPaddingRight())) {
                    selectVehicleInfo();
                    return true;
                }
            }
            return false;
        });
        wmsPsmInLoad = new WmsPsmInLoad();
        binding.setData(wmsPsmInLoad);
    }

    @Override
    public void getScannerData(String data) {
        super.getScannerData(data);
        if (focusedView!=null){

           if (focusedView==productInCode){
               wmsPsmInLoad.setToolingBarcode(data);
               selectVehicleInfo();
           }else if (focusedView==productInLocation){
               productInLocation.setText(data);
           }
        }
    }

    private void selectVehicleInfo() {
        OkGo.<MyResult>post(url + "/wms/pda/product/selectVehicleInfo")
                .params("code", wmsPsmInLoad.getToolingBarcode())
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode()==200){
                            wmsPsmInLoad=gson.fromJson(body.getDataJson(),WmsPsmInLoad.class);
                            binding.setData(wmsPsmInLoad);
                        }
                        myToastUitls.show(body.getMsg());
                    }
                });
    }

    public void productInSubmit(View view) {
        OkGo.<MyResult>post(url + "/wms/pda/product/submitInStoreInfo")
                .upRequestBody(RequestBody.create(JSON, gson.toJson(wmsPsmInLoad)))
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode()==200){
                            wmsPsmInLoad=new WmsPsmInLoad();
                            binding.setData(wmsPsmInLoad);
                        }
                        myToastUitls.show(body.getMsg());
                    }
                });
    }

    private EditText focusedView;

    @Override
    public void onFocusChange(View v, boolean hasFocus) {
        if (hasFocus) {
            Log.e("TAG", "onFocusChange:" + v.getId());
            focusedView = (EditText) v;
        }
    }
}