package com.example.haiwei_mom.wms.raw;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;

import androidx.databinding.DataBindingUtil;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.base.BaseActivity;
import com.example.haiwei_mom.base.MyRecultCall;
import com.example.haiwei_mom.base.MyResult;
import com.example.haiwei_mom.data.RawReturnSubmitBeen;
import com.example.haiwei_mom.data.RawReturnVo;
import com.example.haiwei_mom.databinding.ActivityRawReturnBinding;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.math.BigDecimal;

import okhttp3.RequestBody;

public class RawReturnActivity extends BaseActivity {
    ActivityRawReturnBinding binding;
    private RawReturnVo params;
    private int type;

    @SuppressLint("ClickableViewAccessibility")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = DataBindingUtil.setContentView(this, R.layout.activity_raw_return);
        Intent intent = getIntent();
        String title = intent.getStringExtra("title");
        binding.setTitle(title);
        assert title != null;
        if (title.equals("原材料退库")) {
            type = 1;
        } else if (title.equals("半成品退库")) {
            type = 2;
        }
        binding.rawReturnCode.setOnEditorActionListener((v, actionId, event) -> {
            selectCode();
            return true;
        });
        params = new RawReturnVo();
        binding.setVo(params);
    }

    private void selectCode() {
        OkGo.<MyResult>post(url + "/wms/pda/raw/returnSelectCode")
                .params("code", params.getBatchCode())
                .params("type", type)
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            params = gson.fromJson(body.getDataJson(), RawReturnVo.class);
                            binding.setVo(params);
                            return;
                        }
                        myToastUitls.show(body.getMsg());

                    }
                });
    }

    public void rawReturnSubmit(View view) {
        var planAmount = params.getPlanAmount();
        if (planAmount == null) {
            return;
        }
        var val = Double.parseDouble(planAmount);
        if (val > params.getOutstockQty()) {
            myToastUitls.show("退库数量不能超过原数量");
            return;
        }
        RawReturnSubmitBeen sub = new RawReturnSubmitBeen();
        sub.setMaterialId(params.getMaterialId());
        sub.setBatchCode(params.getBatchCode());
        sub.setPlanAmount(BigDecimal.valueOf(val));
        sub.setPlanLocationCode(params.getLocationCode());
        sub.setMaterialCategories(params.getMaterialCategories());
        sub.setWarehouseId(params.getWarehouseId());
        Log.e("TAG", "rawReturnSubmit:" + params.getOutstockRecordId());
        sub.setOutstockRecordId(params.getOutstockRecordId());
        // 修改出库
        sub.setOutstockRecordId(params.getOutstockRecordId());
        OkGo.<MyResult>post(url + "/wms/pda/raw/returnSubmit")
                .upRequestBody(RequestBody.create(JSON, gson.toJson(sub)))
                .execute(new MyRecultCall(dialog, context) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            finish();
                            // return;
                        }
                        myToastUitls.show(body.getMsg());
                    }
                });
    }

    @Override
    public void getScannerData(String data) {
        super.getScannerData(data);
        binding.rawReturnCode.setText(data);
        selectCode();

    }


}