package com.example.haiwei_mom.wms.raw;

import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.adapter.CheckStoreSelectLocationAdapter;
import com.example.haiwei_mom.base.BaseActivity;
import com.example.haiwei_mom.base.MyRecultCall;
import com.example.haiwei_mom.base.MyResult;
import com.example.haiwei_mom.data.SemiInVo;
import com.example.haiwei_mom.data.StoreInfoVo;
import com.example.haiwei_mom.data.WmsBaseLocationVo;
import com.example.haiwei_mom.data.WmsInventoryCheck;
import com.example.haiwei_mom.databinding.ActivityStoreCheckBinding;
import com.google.gson.reflect.TypeToken;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

public class StoreCheckActivity extends BaseActivity {
    private List<StoreInfoVo> list;
    private List<WmsBaseLocationVo> locationList;
    private ActivityStoreCheckBinding binding;
    private CheckStoreSelectLocationAdapter adapter;
    private  Intent intent;
   private Long storeId;
private   String type;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = DataBindingUtil.setContentView(this, R.layout.activity_store_check);

        type = getIntent().getStringExtra("title");
        binding.setTitle(type);
        initSelectStore(type);
        binding.storeListSpinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                StoreInfoVo storeInfoVo = list.get(position);
                storeId = storeInfoVo.getId();
                selectLocation(type, storeId);
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {

            }
        });
        adapter=new CheckStoreSelectLocationAdapter(this);
        binding.setAdapter(adapter);
        intent = new Intent(this, CheckWorkActivity.class);
    }
   private boolean selectState=true;
    private void selectLocation(String type, Long storeId) {
        // Log.e("TAG", "selectLocation:" + selectState);
        // if (selectState){
        //     selectState=false;
        //     return;
        // }
        OkGo.<MyResult>post(url + "/wms/pda/storeCheck/selectInventorLocationList")
                .params("type", type)
                .params("storeId", storeId)
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            locationList = gson.fromJson(body.getDataJson(), new TypeToken<List<WmsBaseLocationVo>>() {
                            }.getType());
                            adapter.setList(locationList);
                            adapter.notifyDataSetChanged();
                            return;
                        }
                        myToastUitls.show(body.getMsg());
                    }
                });
    }

    private void initSelectStore(String type) {
        OkGo.<MyResult>post(url + "/wms/pda/selectStoreInfo")
                .params("type", type)
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            list = gson.fromJson(body.getDataJson(), new TypeToken<List<StoreInfoVo>>() {
                            }.getType());
                            if (list != null && !list.isEmpty()) {
                                List<String> strings = new ArrayList<>();
                                list.forEach(t -> strings.add(t.getName()));
                                binding.setList(strings);
                            }
                            return;
                        }
                        myToastUitls.show(body.getMsg());
                    }
                });
    }
    
    public void storeCheck1(View view){
        List<String> collect = locationList.stream().map(WmsBaseLocationVo::getLocationCode).collect(Collectors.toList());
        submitOrder(collect);
    }
    public void storeCheck2(View view){
        Log.e("TAG", "storeCheck2:" + locationList.toString());
        List<String> resultList = locationList.stream().filter(WmsBaseLocationVo::isState).map(WmsBaseLocationVo::getLocationCode).collect(Collectors.toList());
        submitOrder(resultList);

    }

    private void submitOrder(List<String> list){
        OkGo.<MyResult>post(url + "/wms/pda/storeCheck/submitOrder")
                .params("storeId",storeId)
                .params("type", type)
                .addUrlParams("location",list)
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            WmsInventoryCheck wmsInventoryCheck=gson.fromJson(body.getDataJson(),WmsInventoryCheck.class);
                            String[] array = list.toArray(new String[0]);
                            intent.putExtra("list",array);
                            intent.putExtra("type",type);
                            intent.putExtra("code",wmsInventoryCheck.getCheckCode());
                            startActivity(intent);
                            finish();
                            return;
                        }
                        myToastUitls.show(body.getMsg());
                    }
                });
    }
}